program chemeqns;
   const
      max = 15;
   type
      ratio = record
                 numer,
                 denom : integer;
              end;
      rational = longint;
      coefary = array [1..max,1..max] of rational;
   var
      themat : coefary;
      numvars,numrows,cntr,cntr2,lastindex,scntr,tempcoef,numelems : integer;
      matdet,tempsol : extended;
      temp : rational;
      badary : boolean;
      answers : array [1..max] of rational;
      wa : array [1..max] of integer;
      ch : char;
      
function gcf (num1,num2 : integer) : integer;
   begin
      if num1 mod num2 = 0 then
         gcf := num2
      else
         gcf := gcf(num2,num1 mod num2);
   end;
      
function makerational (num,den : integer) : rational;
   var
      temp : ratio;
      gcfact,sign : integer;
   begin
      if num = 0 then
         begin
            temp.numer := 0;
            temp.denom := 1;
         end
      else
         begin
            sign := 1 - 2 * ord(num * den < 0);
            num := abs(num);
            den := abs(den);
            gcfact := gcf(num,den);
            temp.numer := num div gcfact * sign;
            temp.denom := den div gcfact;
         end;
      makerational := rational(temp);
   end;
   
function opp (thenum : rational) : rational;
   var
      temp : ratio;
   begin
      temp.denom := ratio(thenum).denom;
      temp.numer := -ratio(thenum).numer;
      opp := rational(temp);
   end;

function add (num1,num2 : ratio) : rational;
   var
      gcfact,lcm,tnum : integer;
   begin
      gcfact := gcf(num1.denom,num2.denom);
      lcm := num1.denom * num2.denom div gcfact;
      tnum := num1.numer * lcm div num1.denom + num2.numer * lcm div num2.denom;
      add := makerational(tnum,lcm);
   end;
      
function multiply (num1,num2 : ratio) : rational;
   begin
      multiply := makerational(num1.numer*num2.numer,num1.denom*num2.denom);
   end;
      
function divide (num1,num2 : ratio) : rational;
   begin
      divide := makerational(num1.numer*num2.denom,num1.denom*num2.numer);
   end;
      
procedure switch (r1,r2 : integer);
   var
      temp : rational;
      cntr : integer;
   begin
      for cntr := 1 to numvars do
         begin
            temp := themat[r1,cntr];
            themat[r1,cntr] := themat[r2,cntr];
            themat[r2,cntr] := temp;
         end;
   end;
   
function iszero (thenum : rational) : boolean;
   begin
      iszero := ratio(thenum).numer = 0;
   end;
   
procedure makeEchelon;
   begin
      cntr := 0;
      badary:= false;
      repeat
         cntr := cntr + 1;
         if iszero(themat[cntr,cntr]) then
            begin
               lastindex := numrows;
               while iszero(themat[lastindex,cntr]) and (lastindex > cntr) do
                  lastindex := lastindex - 1;
               if lastindex = cntr then
                  badary := true
               else
                  switch(cntr,lastindex);
            end;
         if not badary then
            begin
               temp := themat[cntr,cntr];
               for scntr := cntr to numvars do
                  themat[cntr,scntr] := divide(ratio(themat[cntr,scntr]),ratio(temp));
               for cntr2 := cntr + 1 to numrows do
                  if not iszero(themat[cntr2,cntr]) then
                     begin
                        temp := opp(themat[cntr2,cntr]);
                        for scntr := cntr to numvars do
                           themat[cntr2,scntr] := divide(ratio(themat[cntr2,scntr]),ratio(temp));
                     end;
               for cntr2 := (cntr+1) to numrows do
                  if not iszero(themat[cntr2,cntr]) then
                     for scntr := cntr to numvars do
                        themat[cntr2,scntr] := add(ratio(themat[cntr2,scntr]),ratio(themat[cntr,scntr]));
            end;
      until (cntr >= numrows) or badary;
   end;
   
procedure subin;
   var
      sum,temp : rational;
   begin
      answers[numvars] := makerational(abs(ratio(themat[numrows,numrows]).numer*ratio(themat[numrows,numvars]).denom),1);
      answers[numrows] := makerational(abs(ratio(themat[numrows,numrows]).denom*ratio(themat[numrows,numvars]).numer),1);
      for cntr := (numrows-1) downto 1 do
         begin
            sum := makerational(0,1);
            for cntr2 := numvars downto (cntr + 1) do
               begin
                  temp := opp(multiply(ratio(themat[cntr,cntr2]),ratio(answers[cntr2])));
                  sum := add(ratio(sum),ratio(temp));
               end;
            answers[cntr] := sum;
         end;
   end;
   
procedure makewhole;
   var
      cntr,gcfact : integer;
      lcm : longint;
   begin
      lcm := ratio(answers[1]).denom;
      for cntr := 2 to numvars do
         begin
            gcfact := gcf(lcm,ratio(answers[cntr]).denom);
            lcm := lcm div gcfact * ratio(answers[cntr]).denom;
         end;
      for cntr := 1 to numvars do
         wa[cntr] := ratio(answers[cntr]).numer * lcm div ratio(answers[cntr]).denom;
   end;
   
{ user interface }

procedure getinputs;
   const
      electron = '!@';
   type
      chstack = ^stackelem;
      stackelem = record
                     next: chstack;
                     chemnum: integer;
                     numchems: integer;
                  end;
      coefs = array[1..max] of integer;
      symbols = ^srec;
      chem = packed array[1..2] of char;
      srec = record
                thestr: chem;
                next: symbols;
             end;
   var
      elems: symbols;
      thestack: chstack;
      tempc: coefs;

function upper (ch: char): boolean;
   begin
      upper := (ord(ch) > 64) and (ord(ch) < 91);
   end;

function lower (ch: char): boolean;
   begin
      lower := (ord(ch) > 96) and (ord(ch) < 123);
   end;

function isnum (ch: char): boolean;
   begin
      isnum := (ord(ch) > 47) and (ord(ch) < 58);
   end;

procedure push (var thestack: chstack; thenum, times: integer);
   var
      temp: chstack;
   begin
      new(temp);
      temp^.chemnum := thenum;
      temp^.numchems := times;
      temp^.next := thestack;
      thestack := temp;
   end;

procedure pop (var thestack: chstack; var thenum, times: integer);
   var
      temp: chstack;
   begin
      temp := thestack;
      thestack := thestack^.next;
      thenum := temp^.chemnum;
      times := temp^.numchems;
      dispose(temp);
   end;

function stackempty (thestack: chstack): boolean;
   begin
      stackempty := thestack = nil;
   end;

function findchem (thechem: chem): integer;
   var
      temp, newsym, last: symbols;
      cntr: integer;
      found: boolean;
   begin
      temp := elems;
      found := false;
      cntr := 1;
      last := nil;
      while (temp <> nil) and not found do
         begin
            last := temp;
            if temp^.thestr = thechem then
               found := true
            else
               begin
                  temp := temp^.next;
                  cntr := cntr + 1;
               end;
         end;
      if temp = nil then
         begin
            new(newsym);
            newsym^.next := nil;
            newsym^.thestr := thechem;
            if last = nil then
               elems := newsym
            else
               last^.next := newsym;
         end;
      findchem := cntr;
   end;

procedure initcoefs (var temp: coefs);
   var
      cntr: integer;
   begin
      for cntr := 1 to numvars do
         temp[cntr] := 0;
   end;

procedure initstuff;
   var
      cntr: integer;
   begin
      elems := nil;
      thestack := nil;
      writeln('how many chemicals?');
      readln(numvars);
      numrows := numvars - 1;
   end;

procedure multstack (thestack: chstack; thenum: integer);
   var
      temp: chstack;
   begin
      temp := thestack;
      while temp <> nil do
         begin
            temp^.numchems := temp^.numchems * thenum;
            temp := temp^.next;
         end;
   end;

procedure appendstack (var source, dest: chstack);
   var
      thenum, numtimes: integer;
   begin
      while not stackempty(source) do
         begin
            pop(source, thenum, numtimes);
            push(dest, thenum, numtimes);
         end;
   end;

function procline: chstack;
   var
      buffchar: char;
      tempsym: chem;
      numchars: integer;
      newstack: boolean;
      temp, news: chstack;
   begin
      temp := nil;
      newstack := false;
      numchars := 0;
      repeat
         read(buffchar);
         if newstack then
            begin
               if isnum(buffchar) then
                  begin
                     multstack(news, ord(buffchar) - 48);
                     buffchar := chr(0);
                  end;
               appendstack(news, temp);
               newstack := false;
            end;
         if upper(buffchar) then
            begin
               if numchars = 1 then
                  tempsym[2] := ' ';
               if numchars > 0 then
                  push(temp, findchem(tempsym), 1);
               numchars := 1;
               tempsym[1] := buffchar;
            end
         else if lower(buffchar) then
            begin
               numchars := 2;
               tempsym[2] := buffchar;
            end
         else if isnum(buffchar) then
            begin
               if numchars = 1 then
                  tempsym[2] := ' ';
               numchars := 0;
               push(temp, findchem(tempsym), ord(buffchar) - 48);
            end
         else if buffchar = '(' then
            begin
               newstack := true;
               news := procline;
            end;
      until (buffchar = ')') or (buffchar = '-') or (buffchar = '+') or eoln;
      if numchars = 1 then
         tempsym[2] := ' ';
      if numchars > 0 then
         push(temp, findchem(tempsym), 1);
      if (buffchar = '-') or (buffchar = '+') then
         begin
            if eoln then
               numchars := 1
            else
               begin
                  read(buffchar);
                  numchars := ord(buffchar) - 48;
               end;
            if buffchar = '+' then
               numchars := -numchars;
            push(temp, findchem(electron), numchars);
         end;
      procline := temp;
   end;

procedure doline (var thecoefs: coefs);
   var
      thelist, temp: chstack;
      thenum, numtimes: integer;
   begin
      initcoefs(thecoefs);
      thelist := procline;
      readln;
      while thelist <> nil do
         begin
            pop(thelist, thenum, numtimes);
            thecoefs[thenum] := thecoefs[thenum] + numtimes;
         end;
   end;

   begin
      initstuff;
      writeln('how many compounds on the left side?');
      readln(numelems);
      for cntr := 1 to numelems do
         begin
            writeln('please enter the formula for chemical number ', cntr, ' on the left side');
            doline(tempc);
            for cntr2 := 1 to numrows do
               themat[cntr2, cntr] := makerational(tempc[cntr2], 1);
         end;
      for cntr := 1 to numvars - numelems do
         begin
            writeln('please enter the formula for chemical number ', cntr + numelems, ' on the right side');
            doline(tempc);
            for cntr2 := 1 to numrows do
               themat[cntr2, cntr + numelems] := makerational(-tempc[cntr2], 1);
         end;
   end;

   begin
      repeat
         getinputs;
         makeEchelon;
         if badary then
            writeln('no unique solution!')
         else
            begin
               subin;
               makewhole;
               for cntr := 1 to numvars do
                  writeln(wa[cntr]);
            end;
         writeln('More?(y/n)');
         readln(ch);
      until (ch = 'N') or (ch = 'n');
   end.