program chemeqns;
   const
      max = 15;
   type
      ratio = record
                 numer,
                 denom : integer;
              end;
      rational = longint;
      coefary = array [1..max,1..max] of rational;
   var
      themat : coefary;
      numvars,numrows,cntr,cntr2,lastindex,scntr,tempcoef,numelems : integer;
      matdet,tempsol : extended;
      temp : rational;
      badary : boolean;
      answers : array [1..max] of rational;
      wa : array [1..max] of integer;
      
function gcf (num1,num2 : integer) : integer;
   begin
      if num1 mod num2 = 0 then
         gcf := num2
      else
         gcf := gcf(num2,num1 mod num2);
   end;
      
function makerational (num,den : integer) : rational;
   var
      temp : ratio;
      gcfact,sign : integer;
   begin
      if num = 0 then
         begin
            temp.numer := 0;
            temp.denom := 1;
         end
      else
         begin
            sign := 1 - 2 * ord(num * den < 0);
            num := abs(num);
            den := abs(den);
            gcfact := gcf(num,den);
            temp.numer := num div gcfact * sign;
            temp.denom := den div gcfact;
         end;
      makerational := rational(temp);
   end;
   
function opp (thenum : rational) : rational;
   var
      temp : ratio;
   begin
      temp.denom := ratio(thenum).denom;
      temp.numer := -ratio(thenum).numer;
      opp := rational(temp);
   end;

function add (num1,num2 : ratio) : rational;
   var
      gcfact,lcm,tnum : integer;
   begin
      gcfact := gcf(num1.denom,num2.denom);
      lcm := num1.denom * num2.denom div gcfact;
      tnum := num1.numer * lcm div num1.denom + num2.numer * lcm div num2.denom;
      add := makerational(tnum,lcm);
   end;
      
function multiply (num1,num2 : ratio) : rational;
   begin
      multiply := makerational(num1.numer*num2.numer,num1.denom*num2.denom);
   end;
      
function divide (num1,num2 : ratio) : rational;
   begin
      divide := makerational(num1.numer*num2.denom,num1.denom*num2.numer);
   end;
      
procedure switch (r1,r2 : integer);
   var
      temp : rational;
      cntr : integer;
   begin
      for cntr := 1 to numvars do
         begin
            temp := themat[r1,cntr];
            themat[r1,cntr] := themat[r2,cntr];
            themat[r2,cntr] := temp;
         end;
   end;
   
function iszero (thenum : rational) : boolean;
   begin
      iszero := ratio(thenum).numer = 0;
   end;
   
procedure makeEchelon;
   begin
      cntr := 0;
      badary:= false;
      repeat
         cntr := cntr + 1;
         if iszero(themat[cntr,cntr]) then
            begin
               lastindex := numrows;
               while iszero(themat[lastindex,cntr]) and (lastindex > cntr) do
                  lastindex := lastindex - 1;
               if lastindex = cntr then
                  badary := true
               else
                  switch(cntr,lastindex);
            end;
         if not badary then
            begin
               temp := themat[cntr,cntr];
               for scntr := cntr to numvars do
                  themat[cntr,scntr] := divide(ratio(themat[cntr,scntr]),ratio(temp));
               for cntr2 := cntr + 1 to numrows do
                  if not iszero(themat[cntr2,cntr]) then
                     begin
                        temp := opp(themat[cntr2,cntr]);
                        for scntr := cntr to numvars do
                           themat[cntr2,scntr] := divide(ratio(themat[cntr2,scntr]),ratio(temp));
                     end;
               for cntr2 := (cntr+1) to numrows do
                  if not iszero(themat[cntr2,cntr]) then
                     for scntr := cntr to numvars do
                        themat[cntr2,scntr] := add(ratio(themat[cntr2,scntr]),ratio(themat[cntr,scntr]));
            end;
      until (cntr >= numrows) or badary;
   end;
   
procedure subin;
   var
      sum,temp : rational;
   begin
      answers[numvars] := makerational(abs(ratio(themat[numrows,numrows]).numer*ratio(themat[numrows,numvars]).denom),1);
      answers[numrows] := makerational(abs(ratio(themat[numrows,numrows]).denom*ratio(themat[numrows,numvars]).numer),1);
      for cntr := (numrows-1) downto 1 do
         begin
            sum := makerational(0,1);
            for cntr2 := numvars downto (cntr + 1) do
               begin
                  temp := opp(multiply(ratio(themat[cntr,cntr2]),ratio(answers[cntr2])));
                  sum := add(ratio(sum),ratio(temp));
               end;
            answers[cntr] := sum;
         end;
   end;
   
procedure makewhole;
   var
      cntr,gcfact : integer;
      lcm : longint;
   begin
      lcm := ratio(answers[1]).denom;
      for cntr := 2 to numvars do
         begin
            gcfact := gcf(lcm,ratio(answers[cntr]).denom);
            lcm := lcm div gcfact * ratio(answers[cntr]).denom;
         end;
      for cntr := 1 to numvars do
         wa[cntr] := ratio(answers[cntr]).numer * lcm div ratio(answers[cntr]).denom;
   end;
   
   begin
      readln(numvars,numelems);
      numrows := numvars - 1;
      for cntr := 1 to numrows do
         begin
            for cntr2 := 1 to numelems do
               begin
                  read(tempcoef);
                  themat[cntr,cntr2] := makerational(tempcoef,1);
               end;
            for cntr2 := (numelems + 1) to numvars do
               begin
                  read(tempcoef);
                  themat[cntr,cntr2] := makerational(-tempcoef,1);
               end;
            readln;
         end;
      makeEchelon;
      if badary then
         writeln('no unique solution!')
      else
         begin
            subin;
            makewhole;
            for cntr := 1 to numvars do
               writeln(wa[cntr]);
         end;
      readln;
   end.